# pylint: skip-file
import asyncio

import pytest
import pytest_asyncio
from unimatrix.ext.kms import Keychain


TEST_HMAC_KEY: str = '8a983a3d5282c751feadbdd1ad23398f882f65046df4b0ac5a96c93a50669ff7'


@pytest.fixture(scope='session')
def event_loop():
    return asyncio.get_event_loop()


@pytest_asyncio.fixture(scope='session')
async def keychain():
    keychain = Keychain()
    await keychain.register('hmac', [f"literal+hmac:{TEST_HMAC_KEY}?keyid=hmac"])
    await keychain.register('rsa', ['file+pem:pki/rsa.key'])
    await keychain.register('p256', ['file+pem:pki/p256.key'])
    await keychain.register('p384', ['file+pem:pki/p384.key'])
    await keychain.register('p521', ['file+pem:pki/p521.key'])

    return keychain
