"""Declares :class:`Dependency`."""
import fastapi.params


class Dependency(fastapi.params.Depends):
    """Like :class:`fastapi.params.Depends`, but exposes a method to get
    the dependency.
    """

    def __init__(self, use_cache: bool = True):
        super().__init__(dependency=self.resolve, use_cache=use_cache)

    async def resolve(self):
        """Resolve the dependency. The default implementation always raises
        :exc:`NotImplementedError`.
        """
        raise NotImplementedError
