"""Declares :class:`BasePrincipal`."""
from fastapi.params import Depends


class BasePrincipal(Depends): # pragma: no cover
    """A :class:`fastapi.params.Depends` implementation that
    retrieves the current principal from a request object.
    """
    __module__: str = 'cbra.ext.auth'

    def __init__(self):
        super().__init__(dependency=self.get_principal, use_cache=True)

    async def get_principal(self):
        """Return the principal associated with the request."""
        raise NotImplementedError("Subclasses must override this method.")
