# pylint: skip-file
import cbra


class BookResource(cbra.PublicResource):
    name = 'books'
    path_parameter = 'book_id'
    books = {
        1: {
            "id": 1,
            "title": "Voyage au centre de la terre",
            "author": {
                "name": "Jules Verne"
            }
        },
        2: {
            "id": 2,
            "title": "Le tour du monde en quatre-vingts jours",
            "author": {
                "name": "Jules Verne"
            }
        }
    }

    async def list(self):
        return list(sorted(self.books.values(), key=lambda x: x['id']))

    async def retrieve(self, book_id: int):
        return self.books[book_id]


if __name__ == '__main__':
    BookResource.run_simple(port=8000)

    # Run curl http://localhost:8000/books/1 | python3 -m json.tool
    # and see for yourself!
